import os
from xml.sax.saxutils import escape

#
# Tailer handles file file access for MultiTail
#
class Tailer:
	def __init__(self, get_config, file):
		self._get_config = get_config
		self.file = file
		self.name = os.path.basename(file)
		self.ferr = ""
		self.firstread = 1
		self.f = None
		try:
			self.f = open(file, "rb")
			if (os.path.getsize(file) == 0L):
				self.firstread = 0
		except IOError, err:
			self.ferr = "file %s could not be read: %s\n" % (file, err.strerror)
			self.f = None
				
	def close(self):
		if self.f is not None:
			self.f.close()
		
	def add_logname(self, list):
		if (self._get_config("logname")):
			return ["[%s] %s" % (self.name, line) for line in list]
		return list
	
	def error(self, msg):
		return ["[error] "+msg]
	
	def tail(self):
		if (self.ferr != ""):
			return self.error(self.ferr)
		
		if (self.f is None):
			return "no open file."
		
		if (self.firstread == 1):
			self.firstread = 0
			stlines = self._get_config("stlines")
			
			if (stlines==0):
				return
			
			try:
				return self.add_logname(map(escape, self.f.readlines()[-stlines:]))
			except IOError, err:
				return self.error(err.strerror)
		
		nl = []
		while (1):
			try:
				line = self.f.readline()
			except IOError, err:
				self.ferr = err.strerror
				nl.append(self.error(err.strerror))
				break
				
			if (line == ""): break
			nl.append(escape(line))
		
		return self.add_logname(nl)
